Package: wkutils
Title: Utilities for Well-Known Geometry Vectors
Version: 0.1.3
Authors@R: 
    person(given = "Dewey",
           family = "Dunnington",
           role = c("aut", "cre"),
           email = "dewey@fishandwhistle.net",
           comment = c(ORCID = "0000-0002-9415-4582"))
Description: Provides extra utilities for well-known formats in the
  'wk' package that are outside the scope of that package. Utilities
  to parse coordinates from data frames, plot well-known geometry
  vectors, extract meta information from well-known geometry vectors,
  and calculate bounding boxes are provided.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.2.1
Imports: wk (>= 0.3.1), Rcpp, tibble, vctrs
LinkingTo: Rcpp
Suggests: testthat
URL: https://paleolimbot.github.io/wkutils/,
        https://github.com/paleolimbot/wkutils
BugReports: https://github.com/paleolimbot/wkutils/issues
NeedsCompilation: yes
Packaged: 2023-01-17 02:48:34 UTC; deweydunnington
Author: Dewey Dunnington [aut, cre] (<https://orcid.org/0000-0002-9415-4582>)
Maintainer: Dewey Dunnington <dewey@fishandwhistle.net>
Repository: CRAN
Date/Publication: 2023-01-18 08:40:02 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# wkutils

<!-- badges: start -->

[![R-CMD-check](https://github.com/paleolimbot/wkutils/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/paleolimbot/wkutils/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

Whereas the [wk package](https://paleolimbot.github.io/wk/) provides
headers and class definitions for well-known geometry formats, this
package uses those headers to interrogate and transform these vectors.

## Installation

You can install the released version of wkutils from
[CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("wkutils")
```

And the development version from [GitHub](https://github.com/) with:

``` r
# install.packages("remotes")
remotes::install_github("paleolimbot/wkutils")
```

## Example

The gist of the functions in this package:

``` r
library(wkutils)

wkt_coords("POINT (30 10)")
#> # A tibble: 1 × 7
#>   feature_id part_id ring_id     x     y     z     m
#>        <int>   <int>   <int> <dbl> <dbl> <dbl> <dbl>
#> 1          1       1       0    30    10    NA    NA
coords_point_translate_wkt(30, 10)
#> [1] "POINT (30 10)"
wkt_debug("POINT (30 10)")
#> nextFeatureStart(0)
#>     nextGeometryStart(POINT [1], WKReader::PART_ID_NONE)
#>         nextCoordinate(POINT [1], WKCoord(x = 30, y = 10), 0)
#>     nextGeometryEnd(POINT [1], WKReader::PART_ID_NONE)
#> nextFeatureEnd(0)
wkt_set_srid("POINT (30 10)", 1234)
#> [1] "SRID=1234;POINT (30 10)"
wkt_set_z("POINT (30 10)", 1234)
#> [1] "POINT Z (30 10 1234)"
wkt_meta("POINT (30 10)")
#> # A tibble: 1 × 7
#>   feature_id part_id type_id  size  srid has_z has_m
#>        <int>   <int>   <int> <int> <int> <lgl> <lgl>
#> 1          1       1       1     1    NA FALSE FALSE
wkt_ranges("POINT (30 10)")
#> # A tibble: 1 × 8
#>    xmin  ymin  zmin  mmin  xmax  ymax  zmax  mmax
#>   <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl> <dbl>
#> 1    30    10   Inf   Inf    30    10  -Inf  -Inf
```

The package also contains plot methods for `wk::wkb()` and `wk::wkt()`
vectors. These aren’t intended to be high-performance, but are helpful
for debugging geometries.

``` r
plot(wk::wkt("LINESTRING (1 2, 4 7)"))
plot(wk::wkt("POINT (3 4)"), add = T)
```

<img src="man/figures/README-wkt-plot-1.png" width="100%" />

Finally, the package contains slightly faster functions to send points,
lines, and polygons to a graphics device:

``` r
nc_sf <- sf::read_sf(system.file("shape/nc.shp", package = "sf"))
nc_wkb <- wk::as_wkb(sf::st_as_binary(nc_sf$geometry))
wkb_plot_new(nc_wkb)
wkb_draw_polypath(nc_wkb)
```

<img src="man/figures/README-wk-draw-1.png" width="100%" />

#' @keywords internal
"_PACKAGE"

# The following block is used by usethis to automatically manage
# roxygen namespace tags. Modify with care!
## usethis namespace: start
#' @useDynLib wkutils, .registration = TRUE
#' @importFrom Rcpp sourceCpp
#' @import wk
## usethis namespace: end
NULL

#' Generate grid geometries from well-known geometries
#'
#' Using [wkt_meta()] and [wkt_coords()], these functions create graphical objects
#' using the grid package. Vectors that contain geometries of a single dimension
#' are efficiently packed into a [grid::pointsGrob()], [grid::polylineGrob()],
#' or [grid::pathGrob()]. Vectors with mixed types and nested collections are encoded
#' less efficiently using a [grid::gTree()].
#'
#' @inheritParams wk::wkb_translate_wkt
#' @param ... Graphical parameters passed to [grid::gpar()]. These are recycled along
#'   the input. Dynamic dots (e.g., `!!!`) are supported.
#' @param rule Use "winding" if polygon rings are correctly encoded with a winding
#'   direction.
#' @param default.units Coordinate units, which may be defined by the viewport (see
#'   [grid::unit()]). Defaults to native.
#' @param name,vp Passed to [grid::pointsGrob()], [grid::polylineGrob()],
#'   [grid::pathGrob()], or [grid::gTree()] depending on the types of geometries
#'   in the input.
#'
#' @return A [graphical object][grid::grob]
#' @export
#'
#' @examples
#' grid::grid.newpage()
#' grid::grid.draw(wkt_grob("POINT (0.5 0.5)", pch = 16, default.units = "npc"))
#'
wkt_grob <- function(wkt, ..., rule = "evenodd", default.units = "native", name = NULL, vp = NULL) {
  grob_wk_possibly_nested(
    wkt,
    ...,
    unnest_fun = wkt_unnest,
    meta_fun = wkt_meta,
    coords_fun = wkt_coords,
    rule = rule,
    default.units = default.units,
    name = name,
    vp = vp
  )
}

#' @rdname wkt_grob
#' @export
wkb_grob <- function(wkt, ..., rule = "evenodd", default.units = "native", name = NULL, vp = NULL) {
  grob_wk_possibly_nested(
    wkt,
    ...,
    unnest_fun = wkb_unnest,
    meta_fun = wkb_meta,
    coords_fun = wkb_coords,
    rule = rule,
    default.units = default.units,
    name = name,
    vp = vp
  )
}

grob_wk_possibly_nested <- function(x, ..., unnest_fun, meta_fun, coords_fun,
                                    rule, default.units, name, vp) {
  meta <- meta_fun(x)
  gpar_values_all <- vctrs::vec_recycle_common(..., .size = length(x))

  # if there are any collections, unnest everything
  if (any((meta$size > 0) & (meta$type_id == 7))) {
    unnested <- unnest_fun(x, keep_empty = FALSE, keep_multi = TRUE, max_depth = 10)

    lengths <- attr(unnested, "lengths")
    run_length_enc <- structure(
      list(lengths = lengths, values = seq_along(lengths)),
      class = "rle"
    )
    unnested_gpar <- lapply(gpar_values_all, "[", inverse.rle(run_length_enc))

    return(
      wkt_grob(
        unnested, !!!unnested_gpar,
        rule = rule,
        default.units = default.units,
        name = name,
        vp = vp
      )
    )
  }

  coords <- coords_fun(x)

  # grid doesn't do zero-length input, so if there are no coordinates, return
  # an empty grob
  if (nrow(coords) == 0) {
    return(grid::gTree(name = name, vp = vp, children = grid::gList()))
  }

  grob_wk_base(
    meta, coords, gpar_values_all,
    rule = rule,
    default.units = default.units,
    name = name,
    vp = vp
  )
}

grob_wk_base <- function(meta, coords, gpar_values_all, rule, default.units, name = NULL, vp = NULL) {
  # use meta to try to create the most efficient grob possible
  non_empty_types <- meta$type_id[meta$size > 0]

  # non-empty IDs are used by mixed types and polygons
  non_empty_features <- unique(meta$feature_id[meta$size > 0])

  if (all(non_empty_types %in% c(1, 4))) {
    # Need to get a tiny bit creative here, because pointsGrob
    # doesn't have a pathId argument like pathGrob. The key here is
    # to select gpar_values_all so that its rows match the
    # number of actual part_id values for each feature
    part_lengths <- rle(coords$part_id)
    part_row_start <- c(0, cumsum(part_lengths$lengths)) + 1
    part_feature_ids <- coords$feature_id[part_row_start[-length(part_row_start)]]
    gpar_values_all <- lapply(gpar_values_all, "[", part_feature_ids)

    pch <- gpar_values_all$pch %||% 1
    size <- gpar_values_all$size %||% grid::unit(1, "char")
    gpar_values_all$pch <- NULL
    gpar_values_all$size <- NULL

    grid::pointsGrob(
      x = coords$x,
      y = coords$y,
      pch = pch,
      size = size,
      gp = do.call(grid::gpar, gpar_values_all),
      default.units = default.units,
      name = name,
      vp = vp
    )
  } else if (all(non_empty_types %in% c(2, 5))) {
    # Need to get a tiny bit creative here, because polylineGrob
    # doesn't have a pathId argument like pathGrob. The key here is
    # to select gpar_values_all so that its rows match the
    # number of actual part_id values for each feature
    part_lengths <- rle(coords$part_id)
    part_row_start <- c(0, cumsum(part_lengths$lengths)) + 1
    part_feature_ids <- coords$feature_id[part_row_start[-length(part_row_start)]]
    gpar_values_all <- lapply(gpar_values_all, "[", part_feature_ids)

    grid::polylineGrob(
      x = coords$x,
      y = coords$y,
      id.lengths = part_lengths$lengths,
      gp = do.call(grid::gpar, gpar_values_all),
      default.units = default.units,
      name = name,
      vp = vp
    )
  } else if (all(non_empty_types %in% c(3, 6))) {
    non_empty_gpar_values <- lapply(gpar_values_all, "[", non_empty_features)
    grid::pathGrob(
      x = coords$x,
      y = coords$y,
      id = coords$ring_id,
      pathId = coords$feature_id,
      gp = do.call(grid::gpar, non_empty_gpar_values),
      default.units = default.units,
      name = name,
      vp = vp,
      rule = rule
    )
  } else if (all(non_empty_types != 7)) {
    # Mixed input, but no collections (collections should be handled by unnest())
    # not very efficient, but better than failing
    grobs <- lapply(non_empty_features, function(feature_id) {
      grob_wk_base(
        meta[feature_id, ],
        coords[coords$feature_id == feature_id, ],
        gpar_values_all,
        rule = rule,
        default.units = default.units
        # name and vp are passed to the gTree
      )
    })

    grid::gTree(children = do.call(grid::gList, grobs), name = name, vp = vp)
  } else {
    stop("Can't use grob_wk_base() on a GEOMETRYCOLLECTION") # nocov
  }
}

test_that("wkt_grob() works", {
  expect_is(wkt_grob(character(0)), "gTree")
  expect_is(wkt_grob("POINT EMPTY"), "gTree")

  grob_points <- wkt_grob(
    c("POINT (0.1 0.1)", "POINT (0.9 0.9)"),
    pch = c(1, 16), col = c("black", "red"),
    default.units = "npc"
  )
  expect_is(grob_points, "points")
  expect_equal(grob_points$pch, c(1, 16))
  expect_equal(grob_points$gp$col, c("black", "red"))

  # EMPTY items should be recycled along but not included in grob
  grob_points_with_empty <- wkt_grob(
    c("GEOMETRYCOLLECTION EMPTY", "POINT (0.1 0.1)", "POINT (0.9 0.9)"),
    pch = c(3, 1, 16), col = c("magenta", "black", "red"),
    default.units = "npc"
  )
  expect_is(grob_points_with_empty, "points")
  expect_equal(grob_points_with_empty$pch, c(1, 16))
  expect_equal(grob_points_with_empty$gp$col, c("black", "red"))

  # MULTIPOINT has to be handled slightly differently
  grob_multipoint <- wkt_grob(
    c("MULTIPOINT EMPTY", "GEOMETRYCOLLECTION EMPTY",
      "MULTIPOINT ((0.1 0.1), (0.2 0.1))", "POINT (0.5 0.6)"),
    col = c("magenta", "magenta", "black", "green"),
    default.units = "npc"
  )
  expect_is(grob_multipoint, "points")
  expect_identical(grob_multipoint$gp$col, c("black", "black", "green"))

  grob_lines <- wkt_grob(
    c("LINESTRING (0.1 0.1, 0.9 0.9)", "LINESTRING (0.1 0.9, 0.9 0.1)"),
    col = c("black", "red"),
    default.units = "npc"
  )
  expect_is(grob_lines, "polyline")
  expect_equal(grob_lines$gp$col, c("black", "red"))

  # multilines are handled slightly differently because polylineGrob has no
  # pathId argument
  grob_multiline <- wkt_grob(
    c(
      "MULTILINESTRING ((0.1 0.1, 0.9 0.9), (0.9 0.1, 0.1 0.9))",
      "MULTILINESTRING ((0.5 0.5, 0.5 1))"
    ),
    col = c("green", "blue"),
    default.units = "npc"
  )
  expect_is(grob_multiline, "polyline")
  expect_equal(grob_multiline$gp$col, c("green", "green", "blue"))

  grob_poly <- wkt_grob(
    c("POLYGON ((0.1 0.1, 0.9 0.1, 0.9 0.9, 0.1 0.9, 0.1 0.1))"),
    fill = "grey90",
    default.units = "npc"
  )
  expect_is(grob_poly, "pathgrob")
  expect_equal(grob_poly$gp$fill, "grey90")


  grob_mixed <- wkt_grob(
    c("POLYGON ((0.1 0.1, 0.9 0.1, 0.9 0.9, 0.1 0.9, 0.1 0.1))", "POINT (0.5 0.5)"),
    col = c("blue", "green"),
    default.units = "npc"
  )
  expect_is(grob_mixed, "gTree")
  expect_length(grob_mixed$children, 2)
  expect_is(grob_mixed$children[[1]], "pathgrob")
  expect_identical(grob_mixed$children[[1]]$gp$col, "blue")
  expect_is(grob_mixed$children[[2]], "points")
  expect_identical(grob_mixed$children[[2]]$gp$col, "green")

  grob_nested_point <- wkt_grob(
    c(
      "GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0.2 0.2))))",
      "LINESTRING EMPTY",
      "POINT (0.5 0.5)",
      "GEOMETRYCOLLECTION (POINT (0.7 0.7))"
    ),
    col = c("magenta", "black", "cyan", "red"),
    default.units = "npc"
  )
  expect_is(grob_nested_point, "points")
  expect_identical(grob_nested_point$gp$col, c("magenta", "cyan", "red"))

  grid::grid.newpage()
  grid::grid.draw(grob_points)
  grid::grid.draw(grob_points_with_empty)
  grid::grid.draw(grob_multipoint)
  grid::grid.draw(grob_lines)
  grid::grid.draw(grob_multiline)
  grid::grid.draw(grob_poly)
  grid::grid.draw(grob_mixed)
  grid::grid.draw(grob_nested_point)
})

test_that("wkb_grob() works", {
  grob_points <- wkb_grob(
    as_wkb(c("POINT (0.1 0.1)", "POINT (0.9 0.9)")),
    pch = c(1, 16), col = c("black", "red"),
    default.units = "npc"
  )
  expect_is(grob_points, "points")
  expect_equal(grob_points$pch, c(1, 16))
  expect_equal(grob_points$gp$col, c("black", "red"))
})

#' Debug well-known geometry
#'
#' Prints the raw calls to the `WKBGeometryHandler()`. Useful for writing
#' custom C++ handlers and debugging read problems.
#'
#' @inheritParams wk::wkb_translate_wkt
#'
#' @return The input, invisibly
#' @export
#'
#' @examples
#' wkt_debug("MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))")
#' wkt_streamer_debug("MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))")
#' wkb_debug(
#'   wk::wkt_translate_wkb(
#'     "MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))"
#'   )
#' )
#'
wkb_debug <- function(wkb) {
  cpp_debug_wkb(wkb)
  invisible(wkb)
}

#' @rdname wkb_debug
#' @export
wkt_debug <- function(wkt) {
  cpp_debug_wkt(wkt)
  invisible(wkt)
}

#' @rdname wkb_debug
#' @export
wkt_streamer_debug <- function(wkt) {
  cpp_debug_wkt_streamer(wkt)
  invisible(wkt)
}

test_that("debugger works on wkb", {
  point <- as.raw(c(0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
                    0x00, 0x00, 0x00, 0x00, 0x3e, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00,
                    0x00, 0x24, 0x40))

  expect_output(wkb_debug(list(point)), "POINT \\[1\\]")

  point_bad_type <- point
  point_bad_type[2] <- as.raw(0xff)
  expect_output(wkb_debug(list(point_bad_type)), "Invalid integer geometry type")
})

test_that("debugger works on wkt stream", {
  expect_output(wkt_streamer_debug("LINESTRING (30 10, 0 0, 0 1)"), "LINESTRING")
  expect_output(wkt_streamer_debug("POLYGON ((30 10, 0 0, 0 1, 30 10))"), "POLYGON")
  expect_output(wkt_streamer_debug("MULTIPOINT (30 10, 0 0)"), "MULTIPOINT")
  expect_output(wkt_streamer_debug("MULTIPOINT ((30 10), (0 0))"), "MULTIPOINT")
})

test_that("debugger works on wkt", {
  expect_output(wkt_debug("LINESTRING (30 10, 0 0, 0 1)"), "LINESTRING")
  expect_output(wkt_debug("POLYGON ((30 10, 0 0, 0 1, 30 10))"), "POLYGON")
  expect_output(wkt_debug("MULTIPOINT (30 10, 0 0)"), "MULTIPOINT")
  expect_output(wkt_debug("MULTIPOINT ((30 10), (0 0))"), "MULTIPOINT")
})

#' Extract ranges information
#'
#' This is intended to behave the same as [range()], returning the
#' minimum and maximum x, y, z, and m coordinate values.
#'
#' @inheritParams wk::wkb_translate_wkt
#' @param na.rm Pass `TRUE` to not consider missing (nan) values
#' @param finite Pass `TRUE` to only consider finite
#'   (non-missing, non-infinite) values.
#' @export
#'
#' @return A data.frame with columns:
#' - `xmin`, `ymin`, `zmin`, and `mmin`: Minimum coordinate values
#' - `xmax`, `ymax`, `zmax`, and `mmax`: Maximum coordinate values
#'
#' @examples
#' wkt_ranges("POINT (30 10)")
#'
wkb_ranges <- function(wkb, na.rm = FALSE, finite = FALSE) {
  new_data_frame(cpp_ranges_wkb(wkb, naRm = na.rm, onlyFinite = finite))
}

#' @rdname wkb_ranges
#' @export
wkt_ranges <- function(wkt, na.rm = FALSE, finite = FALSE) {
  new_data_frame(cpp_ranges_wkt(wkt, naRm = na.rm, onlyFinite = finite))
}

#' @rdname wkb_ranges
#' @export
wkb_feature_ranges <- function(wkb, na.rm = FALSE, finite = FALSE) {
  new_data_frame(cpp_feature_ranges_wkb(wkb, naRm = na.rm, onlyFinite = finite))
}

#' @rdname wkb_ranges
#' @export
wkt_feature_ranges <- function(wkt, na.rm = FALSE, finite = FALSE) {
  new_data_frame(cpp_feature_ranges_wkt(wkt, naRm = na.rm, onlyFinite = finite))
}

test_that("wkt_ranges() works", {
  expect_identical(
    wkt_ranges(c("POINT (1 2)", "POINT (5 6)")),
    tibble::tibble(
      xmin = 1, ymin = 2, zmin = Inf, mmin = Inf,
      xmax = 5, ymax = 6, zmax = -Inf, mmax = -Inf
    )
  )
  expect_identical(
    wkt_ranges(c("POINT Z (1 2 3)", "POINT (5 6)")),
    tibble::tibble(
      xmin = 1, ymin = 2, zmin = 3, mmin = Inf,
      xmax = 5, ymax = 6, zmax = 3, mmax = -Inf
    )
  )
  expect_identical(
    wkt_ranges(c("POINT ZM (1 2 3 4)", "POINT (5 6)")),
    tibble::tibble(
      xmin = 1, ymin = 2, zmin = 3, mmin = 4,
      xmax = 5, ymax = 6, zmax = 3, mmax = 4
    )
  )
  expect_identical(
    wkt_ranges(c("POINT (1 nan)", "POINT (5 6)")),
    tibble::tibble(
      xmin = 1, ymin = NA_real_, zmin = Inf, mmin = Inf,
      xmax = 5, ymax = NA_real_, zmax = -Inf, mmax = -Inf
    )
  )
  expect_identical(
    wkt_ranges(c("POINT (1 nan)", "POINT (5 6)"), na.rm = TRUE),
    tibble::tibble(
      xmin = 1, ymin = 6, zmin = Inf, mmin = Inf,
      xmax = 5, ymax = 6, zmax = -Inf, mmax = -Inf
    )
  )
  expect_identical(
    wkt_ranges(c("POINT (1 inf)", "POINT (5 6)")),
    tibble::tibble(
      xmin = 1, ymin = 6, zmin = Inf, mmin = Inf,
      xmax = 5, ymax = Inf, zmax = -Inf, mmax = -Inf
    )
  )
  expect_identical(
    wkt_ranges(c("POINT (1 inf)", "POINT (5 6)"), finite = TRUE),
    tibble::tibble(
      xmin = 1, ymin = 6, zmin = Inf, mmin = Inf,
      xmax = 5, ymax = 6, zmax = -Inf, mmax = -Inf
    )
  )

  expect_identical(
    wkt_ranges(c("POINT (nan nan)", "POINT (nan nan)"), finite = TRUE),
    wkt_ranges(character(0))
  )
  expect_identical(
    wkt_ranges(c("POINT (1 2)", "POINT (nan nan)"), finite = TRUE),
    wkt_ranges("POINT (1 2)")
  )
})

test_that("wkb_ranges() works", {
  expect_identical(
    wkb_ranges(wkt_translate_wkb(c("POINT (1 2)", "POINT (5 6)"))),
    tibble::tibble(
      xmin = 1, ymin = 2, zmin = Inf, mmin = Inf,
      xmax = 5, ymax = 6, zmax = -Inf, mmax = -Inf
    )
  )
})

test_that("wkt_feature_ranges() works", {
  expect_identical(
    wkt_feature_ranges(c("POINT ZM (1 2 3 4)", "POINT ZM (5 6 7 8)")),
    tibble::tibble(
      xmin = c(1, 5),
      ymin = c(2, 6),
      zmin = c(3, 7),
      mmin = c(4, 8),
      xmax = c(1, 5),
      ymax = c(2, 6),
      zmax = c(3, 7),
      mmax = c(4, 8)
    )
  )
})

test_that("wkb_feature_ranges() works", {
  expect_identical(
    wkb_feature_ranges(wkt_translate_wkb(c("POINT ZM (1 2 3 4)", "POINT ZM (5 6 7 8)"))),
    tibble::tibble(
      xmin = c(1, 5),
      ymin = c(2, 6),
      zmin = c(3, 7),
      mmin = c(4, 8),
      xmax = c(1, 5),
      ymax = c(2, 6),
      zmax = c(3, 7),
      mmax = c(4, 8)
    )
  )
})

#' Extract meta information
#'
#' @inheritParams wk::wkb_translate_wkt
#' @param recursive Pass `TRUE` to recurse into multi-geometries
#'   and collections to extract meta of sub-geometries
#' @param type A string version of the geometry type (e.g.,
#'   point, linestring, polygon, multipoint, multilinestring,
#'   multipolygon, geometrycollection)
#' @param type_id An integer version of the geometry type
#'
#' @return A data.frame with columns:
#' - `feature_id`: The index of the top-level feature
#' - `nest_id`: The recursion level (if feature is a geometry collection)
#' - `part_id`: The part index (if nested within a multi-geometry or collection)
#' - `type_id`: The type identifier (see [wk_geometry_type()])
#' - `size`: For points and linestrings the number of points, for polygons
#'   the number of rings, and for mutlti-geometries and collection types,
#'   the number of child geometries.
#' - `srid`: The spatial reference identifier as an integer
#'
#' @export
#'
#' @examples
#' wkt_meta("POINT (30 10)")
#' wkt_meta("GEOMETRYCOLLECTION (POINT (30 10))", recursive = FALSE)
#' wkt_meta("GEOMETRYCOLLECTION (POINT (30 10))", recursive = TRUE)
#'
wkb_meta <- function(wkb, recursive = FALSE) {
  new_data_frame(cpp_meta_wkb(wkb, recursive = recursive))
}

#' @rdname wkb_meta
#' @export
wkt_meta <- function(wkt, recursive = FALSE) {
  new_data_frame(cpp_meta_wkt(wkt, recursive = recursive))
}

#' @rdname wkb_meta
#' @export
wkt_streamer_meta <- function(wkt, recursive = FALSE) {
  new_data_frame(cpp_meta_wkt_streamer(wkt, recursive = recursive))
}

#' @rdname wkb_meta
#' @export
wk_geometry_type <- function(type_id) {
  c(
    "point", "linestring", "polygon",
    "multipoint", "multilinestring", "multipolygon",
    "geometrycollection"
  )[as.integer(type_id)]
}

#' @rdname wkb_meta
#' @export
wk_geometry_type_id <- function(type) {
  match(
    type,
    c(
      "point", "linestring", "polygon",
      "multipoint", "multilinestring", "multipolygon",
      "geometrycollection"
    )
  )
}

test_that("wkb_meta() works", {
  expect_identical(
    wkb_meta(wkt_translate_wkb("POINT (30 10)")),
    tibble::tibble(
      feature_id = 1L,
      part_id = 1L,
      type_id = 1L,
      size = 1L,
      srid = NA_integer_,
      has_z = FALSE,
      has_m = FALSE
    )
  )
})

test_that("wkt_meta() works", {
  expect_identical(
    wkt_meta("POINT (30 10)"),
    tibble::tibble(
      feature_id = 1L,
      part_id = 1L,
      type_id = 1L,
      size = 1L,
      srid = NA_integer_,
      has_z = FALSE,
      has_m = FALSE
    )
  )
})

test_that("wkt_streamer_meta() works", {
  # point
  expect_identical(
    wkt_streamer_meta("POINT (30 10)"),
    tibble::tibble(
      feature_id = 1L,
      part_id = 1L,
      type_id = 1L,
      size = NA_integer_,
      srid = NA_integer_,
      has_z = FALSE,
      has_m = FALSE
    )
  )

  # multipoint
  expect_identical(
    wkt_streamer_meta("MULTIPOINT ((30 10))", recursive = FALSE),
    tibble::tibble(
      feature_id = 1L,
      part_id = 1L,
      type_id = 4L,
      size = NA_integer_,
      srid = NA_integer_,
      has_z = FALSE,
      has_m = FALSE
    )
  )

  # multipoint recursive
  expect_identical(
    wkt_streamer_meta("MULTIPOINT ((30 10))", recursive = TRUE),
    tibble::tibble(
      feature_id = c(1L, 1L),
      part_id = c(1L, 2L),
      type_id = c(4L, 1L),
      size = c(NA_integer_, NA_integer_),
      srid = c(NA_integer_, NA_integer_),
      has_z = c(FALSE, FALSE),
      has_m = c(FALSE, FALSE)
    )
  )

  # collection
  expect_identical(
    wkt_streamer_meta("GEOMETRYCOLLECTION (POINT (30 10))", recursive = FALSE),
    tibble::tibble(
      feature_id = 1L,
      part_id = 1L,
      type_id = 7L,
      size = NA_integer_,
      srid = NA_integer_,
      has_z = FALSE,
      has_m = FALSE
    )
  )

  # collection recursive
  expect_identical(
    wkt_streamer_meta(c("GEOMETRYCOLLECTION (POINT (30 10))", NA), recursive = TRUE),
    tibble::tibble(
      feature_id = c(1L, 1L, 2L),
      part_id = c(1L, 2L, NA_integer_),
      type_id = c(7L, 1L, NA_integer_),
      size = c(NA_integer_, NA_integer_, NA_integer_),
      srid = c(NA_integer_, NA_integer_, NA_integer_),
      has_z = c(FALSE, FALSE, NA),
      has_m = c(FALSE, FALSE, NA)
    )
  )
})

test_that("wkt_streamer_meta() works with NULLs", {
  expect_identical(
    wkt_streamer_meta(NA),
    tibble::tibble(
      feature_id = 1L,
      part_id = NA_integer_,
      type_id = NA_integer_,
      size = NA_integer_,
      srid = NA_integer_,
      has_z = NA,
      has_m = NA
    )
  )
})

test_that("wkt_meta() counts coordinates when NULLs are present", {
  expect_identical(
    wkt_meta(c("LINESTRING (20 20, 0 0)", NA)),
    tibble::tibble(
      feature_id = c(1L, 2L),
      part_id = c(1L, NA_integer_),
      type_id = c(2L, NA_integer_),
      size = c(2L, NA_integer_),
      srid = c(NA_integer_, NA_integer_),
      has_z = c(FALSE, NA),
      has_m = c(FALSE, NA)
    )
  )
})

test_that("wkt_streamer_meta() returns SRIDs if present", {
  expect_identical(
    wkt_streamer_meta("SRID=33;POINT (30 10)"),
    tibble::tibble(
      feature_id = 1L,
      part_id = 1L,
      type_id = 1L,
      size = NA_integer_,
      srid = 33L,
      has_z = FALSE,
      has_m = FALSE
    )
  )
})

test_that("wkt_streamer_meta() fails on parse error", {
  expect_error(wkt_streamer_meta("NOPE"), class = "WKParseException")
})

test_that("geometry type converters work", {
  types_str <- c(
    "point", "linestring", "polygon",
    "multipoint", "multilinestring", "multipolygon",
    "geometrycollection"
  )
  expect_identical(wk_geometry_type_id(types_str), 1:7)
  expect_identical(wk_geometry_type(7:1), rev(types_str))
})

#' Flatten nested geometry structures
#'
#' @inheritParams wk::wkb_translate_wkt
#' @param keep_empty If `TRUE`, a GEOMETRYCOLLECTION EMPTY is left as-is
#'   rather than collapsing to length 0.
#' @param keep_multi If `TRUE`, MULTI* geometries are not expanded to sub-features.
#' @param max_depth The maximum recursive GEOMETRYCOLLECTION depth to unnest.
#'
#' @return An unclassed vector with attribute `lengths`, which is an integer vector
#'   with the same length as the input denoting the length to which each
#'   feature was expanded.
#' @export
#'
#' @examples
#' wkt_unnest("GEOMETRYCOLLECTION (POINT (1 2), POINT (3 4))")
#' wkt_unnest("GEOMETRYCOLLECTION EMPTY")
#' wkt_unnest("GEOMETRYCOLLECTION EMPTY", keep_empty = TRUE)
#'
wkt_unnest <- function(wkt, keep_empty = FALSE, keep_multi = TRUE, max_depth = 1) {
  cpp_wkt_unnest(wkt, keep_empty, keep_multi, max_depth)
}

#' @rdname wkt_unnest
#' @export
wkb_unnest <- function(wkb, keep_empty = FALSE, keep_multi = TRUE, max_depth = 1) {
  cpp_wkb_unnest(wkb, keep_empty, keep_multi, max_depth, endian = wk_platform_endian())
}

test_that("wk*_unnest() works", {
  expect_identical(wkt_unnest(NA_character_), structure(NA_character_, lengths = 1L))
  expect_identical(
    wkt_unnest(
      "GEOMETRYCOLLECTION(MULTIPOINT (30 10, 10 10), LINESTRING (0 0, 1 1), GEOMETRYCOLLECTION EMPTY)",
      keep_multi = FALSE, keep_empty = FALSE, max_depth = 2
    ),
    structure(c("POINT (30 10)", "POINT (10 10)", "LINESTRING (0 0, 1 1)"), lengths = 3L)
  )

  expect_identical(
    wkt_unnest(
      "GEOMETRYCOLLECTION(MULTIPOINT (30 10, 10 10), LINESTRING (0 0, 1 1), GEOMETRYCOLLECTION EMPTY)",
      keep_multi = FALSE, keep_empty = TRUE, max_depth = 2
    ),
    structure(
      c("POINT (30 10)", "POINT (10 10)", "LINESTRING (0 0, 1 1)", "GEOMETRYCOLLECTION EMPTY"),
      lengths = 4L
    )
  )

  expect_identical(
    wkt_unnest(
      "SRID=12;GEOMETRYCOLLECTION(MULTIPOINT (30 10, 10 10), LINESTRING (0 0, 1 1), GEOMETRYCOLLECTION EMPTY)",
      keep_multi = FALSE, max_depth = 2
    ),
    structure(
      c("SRID=12;POINT (30 10)", "SRID=12;POINT (10 10)", "SRID=12;LINESTRING (0 0, 1 1)"),
      lengths = 3L
    )
  )

  expect_identical(
    wkb_unnest(
      as_wkb("GEOMETRYCOLLECTION(MULTIPOINT (30 10, 10 10), LINESTRING (0 0, 1 1), GEOMETRYCOLLECTION EMPTY)"),
      keep_multi = TRUE, max_depth = 2, keep_empty = FALSE
    ),
    structure(
      wkt_translate_wkb(c("MULTIPOINT ((30 10), (10 10))", "LINESTRING (0 0, 1 1)")),
      lengths = 2L
    )
  )

  expect_identical(
    wkb_unnest(
      as_wkb("GEOMETRYCOLLECTION(MULTIPOINT (30 10, 10 10), LINESTRING (0 0, 1 1), GEOMETRYCOLLECTION EMPTY)"),
      keep_multi = TRUE, max_depth = 2, keep_empty = TRUE
    ),
    structure(
      wkt_translate_wkb(c("MULTIPOINT ((30 10), (10 10))", "LINESTRING (0 0, 1 1)", "GEOMETRYCOLLECTION EMPTY")),
      lengths =  3L
    )
  )

  expect_identical(
    wkb_unnest(
      as_wkb("GEOMETRYCOLLECTION(MULTIPOINT (30 10, 10 10), LINESTRING (0 0, 1 1), GEOMETRYCOLLECTION EMPTY)"),
      keep_multi = FALSE, max_depth = 2, keep_empty = FALSE
    ),
    structure(
      wkt_translate_wkb(c("POINT (30 10)", "POINT (10 10)", "LINESTRING (0 0, 1 1)")),
      lengths = 3L
    )
  )
})

test_that("wk*_unnest(max_depth) is respected", {
  expect_identical(
    wkt_unnest(
      "GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0 1))))",
      max_depth = 0
    ),
    structure(
      "GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0 1))))",
      lengths = 1L
    )
  )

  expect_identical(
    wkt_unnest(
      "GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0 1))))",
      max_depth = 1
    ),
    structure("GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0 1)))", lengths = 1L)
  )

  expect_identical(
    wkt_unnest(
      "GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0 1))))",
      max_depth = 2
    ),
    structure("GEOMETRYCOLLECTION (POINT (0 1))", lengths = 1L)
  )

  expect_identical(
    wkt_unnest(
      "GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0 1))))",
      max_depth = 3
    ),
    structure("POINT (0 1)", lengths = 1L)
  )

  expect_identical(
    wkt_unnest(
      "SRID=21;GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0 1))))",
      max_depth = 3
    ),
    structure("SRID=21;POINT (0 1)", lengths = 1L)
  )
})

#' Extract coordinates from well-known geometries
#'
#' These functions are optimised for graphics output,
#' which in R require flat coordinate structures. See
#' [graphics::points()], [graphics::lines()],
#' and  [graphics::polypath()] for how to send these
#' to a graphics device, or [grid::pointsGrob()],
#' [grid::linesGrob()], and [grid::pathGrob()] for how
#' to create graphical objects using this output.
#'
#' @inheritParams wk::wkb_translate_wkt
#' @param sep_na Use `TRUE` to separate geometries and linear
#'   rings with a row of `NA`s. This is useful for generating
#'   output that can be fed directly to [graphics::polypath()]
#'   or [graphics::lines()] without modification.
#'
#' @return A data.frame with columns:
#' - `feature_id`: The index of the top-level feature
#' - `part_id`: The part identifier, guaranteed to be unique for every simple geometry
#'   (including those contained within a multi-geometry or collection)
#' - `ring_id`: The ring identifier, guaranteed to be unique for every ring.
#' - `x`, `y`, `z`, `m`: Coordinaate values (both absence and `nan` are recorded
#'   as `NA`)
#'
#' @export
#'
#' @examples
#' text <- c("LINESTRING (0 1, 19 27)", "LINESTRING (-1 -1, 4 10)")
#' wkt_coords(text)
#' wkt_coords(text, sep_na = TRUE)
#'
wkb_coords <- function(wkb, sep_na = FALSE) {
  new_data_frame(cpp_coords_wkb(wkb, sep_na))
}

#' @rdname wkb_coords
#' @export
wkt_coords <- function(wkt, sep_na = FALSE) {
  new_data_frame(cpp_coords_wkt(wkt, sep_na))
}

test_that("wkb_coords() works", {
  # point
  wkb <- wkt_translate_wkb("POINT (30 10)")
  expect_identical(
    wkb_coords(wkb),
    tibble::tibble(
      feature_id = 1L,
      part_id = 1L,
      ring_id = 0L,
      x = 30,
      y = 10,
      z = NA_real_,
      m = NA_real_
    )
  )
})

test_that("wkt_coords() works", {
  # point
  expect_identical(
    wkt_coords("POINT (30 10)"),
    tibble::tibble(
      feature_id = 1L,
      part_id = 1L,
      ring_id = 0L,
      x = 30,
      y = 10,
      z = NA_real_,
      m = NA_real_
    )
  )

  # point zm
  expect_identical(
    wkt_coords("POINT ZM (30 10 1 2)"),
    tibble::tibble(
      feature_id = 1L,
      part_id = 1L,
      ring_id = 0L,
      x = 30,
      y = 10,
      z = 1,
      m = 2
    )
  )

  # linestring
  expect_identical(
    wkt_coords("LINESTRING (30 10, 20 11)"),
    tibble::tibble(
      feature_id = c(1L, 1L),
      part_id = c(1L, 1L),
      ring_id = c(0L, 0L),
      x = c(30, 20),
      y = c(10, 11),
      z = c(NA_real_, NA_real_),
      m = c(NA_real_, NA_real_)
    )
  )

  # polygon
  expect_identical(
    wkt_coords("POLYGON ((30 10, 20 11, 0 0, 30 10))"),
    tibble::tibble(
      feature_id = c(1L, 1L, 1L, 1L),
      part_id = c(1L, 1L, 1L, 1L),
      ring_id = c(1L, 1L, 1L, 1L),
      x = c(30, 20, 0, 30),
      y = c(10, 11, 0, 10),
      z = c(NA_real_, NA_real_, NA_real_, NA_real_),
      m = c(NA_real_, NA_real_, NA_real_, NA_real_)
    )
  )

  # multipoint
  expect_identical(
    wkt_coords("MULTIPOINT ((30 10), (20 11))"),
    tibble::tibble(
      feature_id = c(1L, 1L),
      part_id = c(2L, 3L),
      ring_id = c(0L, 0L),
      x = c(30, 20),
      y = c(10, 11),
      z = c(NA_real_, NA_real_),
      m = c(NA_real_, NA_real_)
    )
  )

  # collection
  # point
  expect_identical(
    wkt_coords("GEOMETRYCOLLECTION (POINT (30 10))"),
    tibble::tibble(
      feature_id = 1L,
      part_id = 2L,
      ring_id = 0L,
      x = 30,
      y = 10,
      z = NA_real_,
      m = NA_real_
    )
  )
})

test_that("sep_na works as intended", {
  holes <- c(
    "POLYGON ((0 0, 10 0, 10 10, 0 10, 0 0), (2 2, 2 4, 4 4, 4 2, 2 2))",
    "POLYGON ((11 11, 20 11, 20 20, 11 20, 11 11), (12 12, 12 14, 14 14, 14 12, 12 12))"
  )

  expect_identical(
    wkt_coords(holes, sep_na = FALSE)$ring_id,
    c(rep(1L, 5), rep(2L, 5), rep(3L, 5), rep(4L, 5))
  )

  expect_identical(
    wkt_coords(holes, sep_na = TRUE)$ring_id,
    c(rep(1L, 5), NA, rep(2L, 5), NA, rep(3L, 5), NA, rep(4L, 5))
  )

  # multi-geometries should only separate between simple geoms
  expect_identical(
    wkt_coords("MULTIPOINT ((30 10), (0 0))", sep_na = TRUE)$part_id,
    c(2L, NA, 3L)
  )

  # null geoms at the start shouldn't insert a separator
  expect_identical(
    wkt_coords(c(NA, "POINT (30 10)"), sep_na = TRUE)$feature_id,
    2L
  )

  # empty geoms at the start shouldn't insert a separator
  expect_identical(
    wkt_coords(c("POINT EMPTY", "POINT (30 10)"), sep_na = TRUE)$feature_id,
    2L
  )
})

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

cpp_coords_point_translate_wkt <- function(x, y, z, m, precision, trim) {
    .Call(`_wkutils_cpp_coords_point_translate_wkt`, x, y, z, m, precision, trim)
}

cpp_coords_point_translate_wkb <- function(x, y, z, m, endian, bufferSize) {
    .Call(`_wkutils_cpp_coords_point_translate_wkb`, x, y, z, m, endian, bufferSize)
}

cpp_coords_linestring_translate_wkt <- function(x, y, z, m, featureId, precision, trim) {
    .Call(`_wkutils_cpp_coords_linestring_translate_wkt`, x, y, z, m, featureId, precision, trim)
}

cpp_coords_linestring_translate_wkb <- function(x, y, z, m, featureId, endian, bufferSize) {
    .Call(`_wkutils_cpp_coords_linestring_translate_wkb`, x, y, z, m, featureId, endian, bufferSize)
}

cpp_coords_polygon_translate_wkt <- function(x, y, z, m, featureId, ringId, precision, trim) {
    .Call(`_wkutils_cpp_coords_polygon_translate_wkt`, x, y, z, m, featureId, ringId, precision, trim)
}

cpp_coords_polygon_translate_wkb <- function(x, y, z, m, featureId, ringId, endian, bufferSize) {
    .Call(`_wkutils_cpp_coords_polygon_translate_wkb`, x, y, z, m, featureId, ringId, endian, bufferSize)
}

cpp_coords_wkb <- function(wkb, sepNA) {
    .Call(`_wkutils_cpp_coords_wkb`, wkb, sepNA)
}

cpp_coords_wkt <- function(wkt, sepNA) {
    .Call(`_wkutils_cpp_coords_wkt`, wkt, sepNA)
}

cpp_debug_wkb <- function(wkb) {
    invisible(.Call(`_wkutils_cpp_debug_wkb`, wkb))
}

cpp_debug_wkt <- function(input) {
    invisible(.Call(`_wkutils_cpp_debug_wkt`, input))
}

cpp_debug_wkt_streamer <- function(input) {
    invisible(.Call(`_wkutils_cpp_debug_wkt_streamer`, input))
}

cpp_wkt_set_srid <- function(wkt, srid, precision = 16L, trim = TRUE) {
    .Call(`_wkutils_cpp_wkt_set_srid`, wkt, srid, precision, trim)
}

cpp_wkb_set_srid <- function(wkb, srid, endian) {
    .Call(`_wkutils_cpp_wkb_set_srid`, wkb, srid, endian)
}

cpp_wkt_set_z <- function(wkt, z, precision = 16L, trim = TRUE) {
    .Call(`_wkutils_cpp_wkt_set_z`, wkt, z, precision, trim)
}

cpp_wkb_set_z <- function(wkb, z, endian) {
    .Call(`_wkutils_cpp_wkb_set_z`, wkb, z, endian)
}

cpp_wkt_transform <- function(wkt, transform, precision = 16L, trim = TRUE) {
    .Call(`_wkutils_cpp_wkt_transform`, wkt, transform, precision, trim)
}

cpp_wkb_transform <- function(wkb, transform, endian) {
    .Call(`_wkutils_cpp_wkb_transform`, wkb, transform, endian)
}

cpp_wkt_has_non_finite <- function(wkt) {
    .Call(`_wkutils_cpp_wkt_has_non_finite`, wkt)
}

cpp_wkb_has_non_finite <- function(wkb) {
    .Call(`_wkutils_cpp_wkb_has_non_finite`, wkb)
}

cpp_wkt_has_missing <- function(wkt) {
    .Call(`_wkutils_cpp_wkt_has_missing`, wkt)
}

cpp_wkb_has_missing <- function(wkb) {
    .Call(`_wkutils_cpp_wkb_has_missing`, wkb)
}

cpp_meta_wkb <- function(wkb, recursive) {
    .Call(`_wkutils_cpp_meta_wkb`, wkb, recursive)
}

cpp_meta_wkt <- function(wkt, recursive) {
    .Call(`_wkutils_cpp_meta_wkt`, wkt, recursive)
}

cpp_meta_wkt_streamer <- function(wkt, recursive) {
    .Call(`_wkutils_cpp_meta_wkt_streamer`, wkt, recursive)
}

cpp_ranges_wkb <- function(wkb, naRm, onlyFinite) {
    .Call(`_wkutils_cpp_ranges_wkb`, wkb, naRm, onlyFinite)
}

cpp_ranges_wkt <- function(wkt, naRm, onlyFinite) {
    .Call(`_wkutils_cpp_ranges_wkt`, wkt, naRm, onlyFinite)
}

cpp_feature_ranges_wkb <- function(wkb, naRm, onlyFinite) {
    .Call(`_wkutils_cpp_feature_ranges_wkb`, wkb, naRm, onlyFinite)
}

cpp_feature_ranges_wkt <- function(wkt, naRm, onlyFinite) {
    .Call(`_wkutils_cpp_feature_ranges_wkt`, wkt, naRm, onlyFinite)
}

cpp_wkt_unnest <- function(wkt, keepEmpty, keepMulti, maxUnnestDepth) {
    .Call(`_wkutils_cpp_wkt_unnest`, wkt, keepEmpty, keepMulti, maxUnnestDepth)
}

cpp_wkb_unnest <- function(wkb, keepEmpty, keepMulti, maxUnnestDepth, endian) {
    .Call(`_wkutils_cpp_wkb_unnest`, wkb, keepEmpty, keepMulti, maxUnnestDepth, endian)
}

#' Plot well-known geometry vectors
#'
#' These plot functions are intended to help debug geometry vectors,
#' and are not intended to be high-performance.
#'
#' @param x A [wkt()] or [wkb()] vector.
#' @param add Should a new plot be created, or should `x` be added to the
#'   existing plot?
#' @param ... Passed to plotting functions for features: [graphics::points()]
#'   for point and multipoint geometries, [graphics::lines()] for linestring
#'   and multilinestring geometries, and [graphics::polypath()] for polygon
#'   and multipolygon geometries.
#' @param bbox The limits of the plot in the form returned by [wkt_ranges()].
#' @param asp,xlab,ylab Passed to [graphics::plot()]
#' @param rule The rule to use for filling polygons (see [graphics::polypath()])
#'
#' @return `x`, invisibly
#' @export
#'
#' @examples
#' wkt_plot("POINT (30 10)")
#'
wkt_plot <- function(x, ...,
                     asp = 1, bbox = NULL, xlab = "", ylab = "",
                     rule = "evenodd", add = FALSE) {
  plot_wk(
    x, wkt_ranges, wkt_meta, wkt_coords, wkt_unnest,
    ...,
    asp = asp, bbox = bbox, xlab = xlab,
    rule = rule, add = add
  )
}

#' @rdname wkt_plot
#' @export
wkb_plot <- function(x, ...,
                     asp = 1, bbox = NULL, xlab = "", ylab = "",
                     rule = "evenodd", add = FALSE) {
  plot_wk(
    x, wkb_ranges, wkb_meta, wkb_coords, wkb_unnest,
    ...,
    asp = asp, bbox = bbox, xlab = xlab,
    rule = rule, add = add
  )
}

plot_wk <- function(x, ranges_fun, meta_fun, coords_fun, unnest_fun, ...,
                    asp = 1, bbox = NULL, xlab = "", ylab = "",
                    rule = "evenodd", add = FALSE) {
  if (!add) {
    bbox <- unclass(bbox)
    bbox <- bbox %||% ranges_fun(x, finite = TRUE)
    xlim <- c(bbox$xmin, bbox$xmax)
    ylim <- c(bbox$ymin, bbox$ymax)

    graphics::plot(
      numeric(0),
      numeric(0),
      xlim = xlim,
      ylim = ylim,
      xlab = xlab,
      ylab = ylab,
      asp = asp
    )
  }

  plot_add_wk(x, meta_fun, coords_fun, unnest_fun, ..., rule = rule)
}

plot_add_wk <- function(x, meta_fun, coords_fun, unnest_fun, ..., rule = "evenodd") {
  # evaluate dots, wrap scalar types in a list(), and vectorize
  x <- unclass(x)
  dots <- list(..., rule = rule)
  is_scalar <- !vapply(dots, vctrs::vec_is, logical(1))
  dots[is_scalar] <- lapply(dots[is_scalar], list)
  dots_tbl <- vctrs::vec_recycle_common(!!!dots, .size = length(x))
  meta <- unclass(meta_fun(x, recursive = FALSE))

  # using for() because the user interrupt is respected in RStudio
  for (i in seq_along(x)) {
    coords <- coords_fun(x[i], sep_na = TRUE)[c("x", "y")]
    if (nrow(coords) == 0) {
      next
    }

    dots_item <- lapply(dots_tbl, "[[", i)
    type_id <- meta$type[i]
    args <- c(coords, dots_item)

    if (type_id == 1 || type_id == 4) {
      args$rule <- NULL
      do.call(graphics::points, args)
    } else if (type_id == 2 || type_id == 5) {
      args$rule <- NULL
      do.call(graphics::lines, args)
    } else if (type_id == 3 || type_id == 6) {
      do.call(graphics::polypath, args)
    } else if (type_id == 7) {
      unnested <- unnest_fun(x[i])
      do.call(
        plot_add_wk,
        c(
          list(unnested, meta_fun = meta_fun, coords_fun = coords_fun, unnest_fun = unnest_fun),
          dots_item
        )
      )
    } else {
      stop("Unknown geometry type", call. = FALSE) # nocov
    }
  }

  invisible(x)
}

#' Modify well-known geometries
#'
#' @inheritParams wk::wkb_translate_wkt
#' @param srid An integer spatial reference identifier with a user-defined meaning.
#'   Use `NA` to unset this value.
#' @param z A Z value that will be assigned to every coordinate in each feature.
#'   Use `NA` to unset this value.
#' @param trans A 3x3 transformation matrix that will be applied to all coordinates
#'   in the input.
#'
#' @return An unclassed well-known vector with the same type
#'   as the input.
#' @export
#'
#' @examples
#' wkt_set_srid("POINT (30 10)", 1234)
#' wkt_set_z("POINT (30 10)", 1234)
#' wkt_transform(
#'   "POINT (0 0)",
#'   # translation +12 +13
#'   matrix(c(1, 0, 0, 0, 1, 0, 12, 13, 1), ncol = 3)
#' )
#'
wkt_set_srid <- function(wkt, srid, precision = 16, trim = TRUE)  {
  recycled <- vctrs::vec_recycle_common(wkt, srid)
  cpp_wkt_set_srid(recycled[[1]], recycled[[2]], precision, trim)
}

#' @rdname wkt_set_srid
#' @export
wkb_set_srid <- function(wkb, srid) {
  recycled <- vctrs::vec_recycle_common(wkb, srid)
  cpp_wkb_set_srid(recycled[[1]], recycled[[2]], wk_platform_endian())
}

#' @rdname wkt_set_srid
#' @export
wkt_set_z <- function(wkt, z, precision = 16, trim = TRUE)  {
  recycled <- vctrs::vec_recycle_common(wkt, z)
  cpp_wkt_set_z(recycled[[1]], recycled[[2]], precision, trim)
}

#' @rdname wkt_set_srid
#' @export
wkb_set_z <- function(wkb, z) {
  recycled <- vctrs::vec_recycle_common(wkb, z)
  cpp_wkb_set_z(recycled[[1]], recycled[[2]], wk_platform_endian())
}

#' @rdname wkt_set_srid
#' @export
wkt_transform <- function(wkt, trans, precision = 16, trim = TRUE)  {
  cpp_wkt_transform(wkt, as_trans_matrix(trans)[c(1, 2), ], precision, trim)
}

#' @rdname wkt_set_srid
#' @export
wkb_transform <- function(wkb, trans)  {
  cpp_wkb_transform(wkb, as_trans_matrix(trans)[c(1, 2), ], endian = wk_platform_endian())
}

as_trans_matrix <- function(trans) {
  trans <- as.matrix(trans)
  stopifnot(ncol(trans) == 3, nrow(trans) == 3)
  trans
}

test_that("wkt_set_srid works", {
  expect_identical(wkt_set_srid(character(0), 1234), character(0))
  expect_identical(wkt_set_srid(NA_character_, 1234), NA_character_)
  expect_identical(
    wkt_set_srid("POINT (30 10)", 1234),
    "SRID=1234;POINT (30 10)"
  )

  expect_identical(
    wkt_set_srid("POINT (30 10)", c(1234, 5678)),
    c("SRID=1234;POINT (30 10)", "SRID=5678;POINT (30 10)")
  )

  expect_identical(
    wkt_set_srid(c("POINT (30 10)", "POINT (10 10)"), c(1234, 5678)),
    c("SRID=1234;POINT (30 10)", "SRID=5678;POINT (10 10)")
  )

  expect_identical(
    wkt_set_srid(c("POINT (30 10)", "POINT (10 10)"), c(1234)),
    c("SRID=1234;POINT (30 10)", "SRID=1234;POINT (10 10)")
  )
})

test_that("wkb_set_srid works", {
  expect_identical(wkb_set_srid(list(), 1234), list())
  expect_identical(wkb_set_srid(list(NULL), 1234), list(NULL))
  expect_identical(
    wkb_set_srid(as_wkb("POINT (30 10)"), 1234),
    unclass(as_wkb("SRID=1234;POINT (30 10)"))
  )
})

test_that("wkt_set_z works", {
  expect_identical(wkt_set_z(character(0), 1234), character(0))
  expect_identical(wkt_set_z(NA_character_, 1234), NA_character_)
  expect_identical(
    wkt_set_z("POINT (30 10)", 1234),
    "POINT Z (30 10 1234)"
  )

  expect_identical(
    wkt_set_z("POINT (30 10)", c(1234, 5678)),
    c("POINT Z (30 10 1234)", "POINT Z (30 10 5678)")
  )

  expect_identical(
    wkt_set_z(c("POINT (30 10)", "POINT (10 10)"), c(1234, 5678)),
    c("POINT Z (30 10 1234)", "POINT Z (10 10 5678)")
  )

  expect_identical(
    wkt_set_z(c("POINT (30 10)", "POINT (10 10)"), c(1234)),
    c("POINT Z (30 10 1234)", "POINT Z (10 10 1234)")
  )
})

test_that("wkb_set_z works", {
  expect_identical(wkb_set_z(list(), 1234), list())
  expect_identical(wkb_set_z(list(NULL), 1234), list(NULL))
  expect_identical(
    wkb_set_z(as_wkb("POINT (30 10)"), 1234),
    unclass(as_wkb("POINT Z (30 10 1234)"))
  )
})

test_that("wkt_transform works", {
  tx <- 3
  ty <- 7
  t_test_trans <- matrix(c(1, 0, 0, 0, 1, 0, tx, ty, 1), ncol = 3)

  t_test_rotate45 <- matrix(
    c(0.707106781186548, -0.707106781186547, 0, 0.707106781186547,
      0.707106781186548, 0, 0, 0, 1),
    ncol = 3
  )

  expect_identical(wkt_transform("POINT (0 0)", t_test_trans), "POINT (3 7)")
  expect_identical(wkt_transform("POINT (0 0)", t_test_rotate45), "POINT (0 0)")
  expect_identical(
    wkt_transform(sprintf("POINT (%s 0)", sqrt(2)), t_test_rotate45, precision = 10),
    "POINT (1 -1)"
  )

  expect_identical(
    wkt_transform(
      sprintf("POINT (%s 0)", sqrt(2)),
      t_test_trans %*% t_test_rotate45,
      precision = 10
    ),
    "POINT (4 6)"
  )
})

test_that("wkb_transform works", {
  tx <- 3
  ty <- 7
  t_test_trans <- matrix(c(1, 0, 0, 0, 1, 0, tx, ty, 1), ncol = 3)
  expect_identical(
    wkb_transform(as_wkb("POINT (0 0)"), t_test_trans),
    wkt_translate_wkb("POINT (3 7)")
  )
})

#' Draw well-known geometries
#'
#' These functions send well-known geometry vectors to a
#' graphics device using [graphics::points()],
#' [graphics::lines()], and [graphics::polypath()]. These are
#' minimal wrappers aimed at developers who need to visualize
#' test data: they do not check geometry type and are unlikely
#' to work with vectorized graphical parameters in `...`. Use
#' the `wk*_plot_new()` functions to initialize a plot using the
#' extent of all coordinates in the vector.
#'
#' @inheritParams wk::wkb_translate_wkt
#' @param ... Passed to [graphics::points()],
#'   [graphics::lines()], or [graphics::polypath()]
#' @param rule Passed to [graphics::polypath()]
#' @param asp,xlab,ylab,main Passed to [graphics::plot()] to
#'   initialize a new plot.
#'
#' @return The input, invisibly
#' @export
#'
#' @examples
#' x <- "POLYGON ((0 0, 10 0, 10 10, 0 10, 0 0))"
#'
#' wkt_plot_new(x)
#' wkt_draw_polypath(x, col = "grey90")
#' wkt_draw_lines(x, col = "red")
#' wkt_draw_points(x)
#'
wkb_draw_points <- function(wkb, ...) {
  wkcoords_draw_points(wkb_coords(wkb), ...)
  invisible(wkb)
}

#' @rdname wkb_draw_points
#' @export
wkt_draw_points <- function(wkt, ...) {
  wkcoords_draw_points(wkt_coords(wkt), ...)
  invisible(wkt)
}

#' @rdname wkb_draw_points
#' @export
wkb_draw_lines <- function(wkb, ...) {
  wkcoords_draw_lines(wkb_coords(wkb, sep_na = TRUE), ...)
  invisible(wkb)
}

#' @rdname wkb_draw_points
#' @export
wkt_draw_lines <- function(wkt, ...) {
  wkcoords_draw_lines(wkt_coords(wkt, sep_na = TRUE), ...)
  invisible(wkt)
}

#' @rdname wkb_draw_points
#' @export
wkb_draw_polypath <- function(wkb, ..., rule = "evenodd") {
  wkcoords_draw_polypath(wkb_coords(wkb, sep_na = TRUE), ..., rule = rule)
  invisible(wkb)
}

#' @rdname wkb_draw_points
#' @export
wkt_draw_polypath <- function(wkt, ..., rule = "evenodd") {
  wkcoords_draw_polypath(wkt_coords(wkt, sep_na = TRUE), ..., rule = rule)
  invisible(wkt)
}

#' @rdname wkb_draw_points
#' @export
wkb_plot_new <- function(wkb, ..., asp = 1, xlab = "", ylab = "", main = deparse(substitute(wkb))) {
  wkranges_plot_new(wkb_ranges(wkb, finite = TRUE), ..., asp = asp, xlab = xlab, ylab = ylab, main = main)
  invisible(wkb)
}

#' @rdname wkb_draw_points
#' @export
wkt_plot_new <- function(wkt, ..., asp = 1, xlab = "", ylab = "", main = deparse(substitute(wkt))) {
  wkranges_plot_new(wkt_ranges(wkt, finite = TRUE), ..., asp = asp, xlab = xlab, ylab = ylab, main = main)
  invisible(wkt)
}

wkcoords_draw_points <- function(coords, ...) {
  graphics::points(coords$x, coords$y, ...)
}

wkcoords_draw_lines <- function(coords, ...) {
  graphics::lines(coords$x, coords$y, ...)
}

wkcoords_draw_polypath <- function(coords, ..., rule = "evenodd") {
  graphics::polypath(coords$x, coords$y, ..., rule = rule)
}

wkranges_plot_new <- function(ranges, ..., xlab = "", ylab = "", main = "") {
  graphics::plot(
    double(), double(),
    ...,
    xlim = c(ranges$xmin, ranges$xmax),
    ylim = c(ranges$ymin, ranges$ymax),
    xlab = xlab,
    ylab = ylab,
    main = main
  )
}

test_that("wkt_draw_* works", {
  x <- "POLYGON ((0 0, 10 0, 10 10, 0 10, 0 0))"

  expect_identical(wkt_plot_new(x, main  = "wkt_draw_*()"), x)
  expect_identical(wkt_draw_polypath(x, col = "grey90"), x)
  expect_identical(wkt_draw_lines(x, col = "red"), x)
  expect_identical(wkt_draw_points(x, pch = 16), x)
})

test_that("wkb_draw_* works", {
  x <- wkt_translate_wkb("POLYGON ((0 0, 10 0, 10 10, 0 10, 0 0))")

  expect_identical(wkb_plot_new(x, main  = "wkb_draw_*()"), x)
  expect_identical(wkb_draw_polypath(x, col = "grey90"), x)
  expect_identical(wkb_draw_lines(x, col = "red"), x)
  expect_identical(wkb_draw_points(x, pch = 16), x)
})

#' Parse coordinates into well-known formats
#'
#' These functions provide the reverse function of [wkt_coords()]
#' and company: they parse vectors of coordinate values into well-known
#' formats. Polygon rings are automatically closed, as
#' closed rings are assumed or required by many parsers.
#'
#' @param x,y,z,m Vectors of coordinate values
#' @param feature_id,ring_id Vectors for which a change in
#'   sequential values indicates a new feature or ring. Use [factor()]
#'   to convert from a character vector.
#' @param buffer_size The buffer size to use when converting to WKB.
#' @inheritParams wk::wkb_translate_wkt
#'
#' @return `*_translate_wkt()` returns a character vector of
#'   well-known text; `*_translate_wkb()` returns a list
#'   of raw vectors.
#'
#' @export
#'
#' @examples
#' coords_point_translate_wkt(1:3, 2:4)
#' coords_linestring_translate_wkt(1:5, 2:6, feature_id = c(1, 1, 1, 2, 2))
#' coords_polygon_translate_wkt(c(0, 10, 0), c(0, 0, 10))
#'
coords_point_translate_wkt <- function(x, y, z = NA, m = NA,
                                       precision = 16, trim = TRUE) {
  recycled <- vctrs::vec_recycle_common(x, y, z, m)
  cpp_coords_point_translate_wkt(
    recycled[[1]], recycled[[2]], recycled[[3]], recycled[[4]],
    precision = precision,
    trim = trim
  )
}

#' @rdname coords_point_translate_wkt
#' @export
coords_point_translate_wkb <- function(x, y, z = NA, m = NA,
                                       endian = wk::wk_platform_endian(), buffer_size = 2048) {
  recycled <- vctrs::vec_recycle_common(x, y, z, m)
  cpp_coords_point_translate_wkb(
    recycled[[1]], recycled[[2]], recycled[[3]], recycled[[4]],
    endian = endian,
    bufferSize = buffer_size
  )
}

#' @rdname coords_point_translate_wkt
#' @export
coords_linestring_translate_wkt <- function(x, y, z = NA, m = NA, feature_id = 1L,
                                       precision = 16, trim = TRUE) {
  recycled <- vctrs::vec_recycle_common(x, y, z, m, feature_id)
  cpp_coords_linestring_translate_wkt(
    recycled[[1]], recycled[[2]], recycled[[3]], recycled[[4]],
    recycled[[5]],
    precision = precision,
    trim = trim
  )
}

#' @rdname coords_point_translate_wkt
#' @export
coords_linestring_translate_wkb <- function(x, y, z = NA, m = NA, feature_id = 1L,
                                            endian = wk::wk_platform_endian(), buffer_size = 2048) {
  recycled <- vctrs::vec_recycle_common(x, y, z, m, feature_id)
  cpp_coords_linestring_translate_wkb(
    recycled[[1]], recycled[[2]], recycled[[3]], recycled[[4]],
    recycled[[5]],
    endian = endian,
    bufferSize = buffer_size
  )
}

#' @rdname coords_point_translate_wkt
#' @export
coords_polygon_translate_wkt <- function(x, y, z = NA, m = NA, feature_id = 1L, ring_id = 1L,
                                         precision = 16, trim = TRUE) {
  recycled <- vctrs::vec_recycle_common(x, y, z, m, feature_id, ring_id)
  cpp_coords_polygon_translate_wkt(
    recycled[[1]], recycled[[2]], recycled[[3]], recycled[[4]],
    recycled[[5]], recycled[[6]],
    precision = precision,
    trim = trim
  )
}

#' @rdname coords_point_translate_wkt
#' @export
coords_polygon_translate_wkb <- function(x, y, z = NA, m = NA, feature_id = 1L, ring_id = 1L,
                                         endian = wk::wk_platform_endian(), buffer_size = 2048) {
  recycled <- vctrs::vec_recycle_common(x, y, z, m, feature_id, ring_id)
  cpp_coords_polygon_translate_wkb(
    recycled[[1]], recycled[[2]], recycled[[3]], recycled[[4]],
    recycled[[5]], recycled[[6]],
    endian = endian,
    bufferSize = buffer_size
  )
}

test_that("coords_*_translate_wkt() works", {
  # point
  expect_identical(coords_point_translate_wkt(double(), double()), character(0))
  expect_identical(coords_point_translate_wkt(NA, NA), "POINT EMPTY")
  expect_identical(
    coords_point_translate_wkt(1:3, 2:4),
    c("POINT (1 2)", "POINT (2 3)", "POINT (3 4)")
  )
  expect_identical(
    coords_point_translate_wkt(1:3, 2:4, 3:5),
    c("POINT Z (1 2 3)", "POINT Z (2 3 4)", "POINT Z (3 4 5)")
  )
  expect_identical(
    coords_point_translate_wkt(1:3, 2:4, NA, 3:5),
    c("POINT M (1 2 3)", "POINT M (2 3 4)", "POINT M (3 4 5)")
  )
  expect_identical(
    coords_point_translate_wkt(1:3, 2:4, 3:5, 4:6),
    c("POINT ZM (1 2 3 4)", "POINT ZM (2 3 4 5)", "POINT ZM (3 4 5 6)")
  )

  # linestring
  expect_identical(coords_linestring_translate_wkt(double(), double()), character(0))
  expect_identical(
    coords_linestring_translate_wkt(1:3, 2:4),
    "LINESTRING (1 2, 2 3, 3 4)"
  )
  expect_identical(
    coords_linestring_translate_wkt(1:3, 2:4, 3:5),
    "LINESTRING Z (1 2 3, 2 3 4, 3 4 5)"
  )
  expect_identical(
    coords_linestring_translate_wkt(1:3, 2:4, NA, 3:5),
    "LINESTRING M (1 2 3, 2 3 4, 3 4 5)"
  )
  expect_identical(
    coords_linestring_translate_wkt(1:3, 2:4, 3:5, 4:6),
    "LINESTRING ZM (1 2 3 4, 2 3 4 5, 3 4 5 6)"
  )

  expect_identical(
    coords_linestring_translate_wkt(1:5, 2:6, feature_id = c(1, 1, 1, 2, 2)),
    c("LINESTRING (1 2, 2 3, 3 4)", "LINESTRING (4 5, 5 6)")
  )

  # polygon
  expect_identical(coords_polygon_translate_wkt(double(), double()), character(0))
  expect_identical(
    coords_polygon_translate_wkt(c(0, 10, 0), c(0, 0, 10)),
    "POLYGON ((0 0, 10 0, 0 10, 0 0))"
  )
  expect_identical(
    coords_polygon_translate_wkt(c(0, 10, 0, 0), c(0, 0, 10, 0)),
    "POLYGON ((0 0, 10 0, 0 10, 0 0))"
  )

  expect_identical(
    coords_polygon_translate_wkt(
      c(20, 10, 10, 30, 45, 30, 20, 20),
      c(35, 30, 10, 5, 20, 20, 15, 25),
      ring_id = c(1, 1, 1, 1, 1, 2, 2, 2)
    ),
    "POLYGON ((20 35, 10 30, 10 10, 30 5, 45 20, 20 35), (30 20, 20 15, 20 25, 30 20))"
  )

  expect_identical(
    coords_polygon_translate_wkt(
      c(20, 10, 10, 30, 45, 30, 20, 20, 40, 20, 45),
      c(35, 30, 10, 5, 20, 20, 15, 25, 40, 45, 30),
      feature_id = c(rep(1, 8), rep(2, 3)),
      ring_id = c(1, 1, 1, 1, 1, 2, 2, 2, 1, 1, 1)
    ),
    c(
      "POLYGON ((20 35, 10 30, 10 10, 30 5, 45 20, 20 35), (30 20, 20 15, 20 25, 30 20))",
      "POLYGON ((40 40, 20 45, 45 30, 40 40))"
    )
  )

  expect_identical(
    coords_polygon_translate_wkt(
      c(20, 10, 10, 30, 45, 30, 20, 20, 40, 20, 45),
      c(35, 30, 10, 5, 20, 20, 15, 25, 40, 45, 30),
      feature_id = c(rep(1, 8), rep(2, 3)),
      # new ring should be detected on new feature_id
      ring_id = c(1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2)
    ),
    c(
      "POLYGON ((20 35, 10 30, 10 10, 30 5, 45 20, 20 35), (30 20, 20 15, 20 25, 30 20))",
      "POLYGON ((40 40, 20 45, 45 30, 40 40))"
    )
  )
})

test_that("coords_*_translate_wkb() works", {
  expect_identical(
    coords_point_translate_wkb(1:3, 2:4),
    wkt_translate_wkb(c("POINT (1 2)", "POINT (2 3)", "POINT (3 4)"))
  )
  expect_identical(
    coords_linestring_translate_wkb(1:5, 2:6, feature_id = c(1, 1, 1, 2, 2)),
    wkt_translate_wkb(c("LINESTRING (1 2, 2 3, 3 4)", "LINESTRING (4 5, 5 6)"))
  )
  expect_identical(
    coords_polygon_translate_wkb(
      c(20, 10, 10, 30, 45, 30, 20, 20, 40, 20, 45),
      c(35, 30, 10, 5, 20, 20, 15, 25, 40, 45, 30),
      feature_id = c(rep(1, 8), rep(2, 3)),
      ring_id = c(1, 1, 1, 1, 1, 2, 2, 2, 1, 1, 1)
    ),
    wkt_translate_wkb(
      c(
        "POLYGON ((20 35, 10 30, 10 10, 30 5, 45 20, 20 35), (30 20, 20 15, 20 25, 30 20))",
        "POLYGON ((40 40, 20 45, 45 30, 40 40))"
      )
    )
  )
})

#' Test well-known geometries for missing and non-finite coordinates
#'
#' Note that EMTPY geometries are considered finite and non-missing.
#' Use the `size` column of [wkt_meta()] to test for empty geometries.
#'
#' @inheritParams wk::wkb_translate_wkt
#'
#' @return A logical vector with the same length as the input.
#' @export
#'
#' @examples
#' wkt_has_missing("POINT (0 1)")
#' wkt_has_missing("POINT (nan nan)")
#' wkt_has_missing("POINT (inf inf)")
#'
#' wkt_is_finite("POINT (0 1)")
#' wkt_is_finite("POINT (nan nan)")
#' wkt_is_finite("POINT (inf inf)")
#'
wkt_has_missing <- function(wkt) {
  cpp_wkt_has_missing(wkt)
}

#' @rdname wkt_has_missing
#' @export
wkb_has_missing <- function(wkb) {
  cpp_wkb_has_missing(wkb)
}

#' @rdname wkt_has_missing
#' @export
wkt_is_finite <- function(wkt) {
  !cpp_wkt_has_non_finite(wkt)
}

#' @rdname wkt_has_missing
#' @export
wkb_is_finite <- function(wkb) {
  !cpp_wkb_has_non_finite(wkb)
}

test_that("wkt_has_missing() / wkt_is_finite() works", {
  expect_identical(wkt_has_missing(character(0)), logical(0))
  expect_false(wkt_has_missing("POINT EMPTY"))
  expect_false(wkt_has_missing("POINT (0 1)"))
  expect_true(wkt_has_missing("POINT (nan nan)"))
  expect_false(wkt_has_missing("POINT (inf inf)"))

  expect_true(wkt_is_finite("POINT EMPTY"))
  expect_true(wkt_is_finite("POINT (0 1)"))
  expect_false(wkt_is_finite("POINT (nan nan)"))
  expect_false(wkt_is_finite("POINT (inf inf)"))
})

test_that("wkb_has_missing() / wkb_is_finite() works", {
  expect_identical(wkb_has_missing(list()), logical(0))
  # WKB can't do empty point without missing coords
  expect_false(wkb_has_missing(as_wkb("LINESTRING EMPTY")))
  expect_false(wkb_has_missing(as_wkb("POINT (0 1)")))
  expect_true(wkb_has_missing(as_wkb("POINT (nan nan)")))
  expect_false(wkb_has_missing(as_wkb("POINT (inf inf)")))

  expect_identical(wkb_is_finite(list()), logical(0))
  expect_true(wkb_is_finite(as_wkb("LINESTRING EMPTY")))
  expect_true(wkb_is_finite(as_wkb("POINT (0 1)")))
  expect_false(wkb_is_finite(as_wkb("POINT (nan nan)")))
  expect_false(wkb_is_finite(as_wkb("POINT (inf inf)")))
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wkutils-package.R
\docType{package}
\name{wkutils-package}
\alias{wkutils}
\alias{wkutils-package}
\title{wkutils: Utilities for Well-Known Geometry Vectors}
\description{
Provides extra utilities for well-known formats in the 'wk' package that are outside the scope of that package. Utilities to parse coordinates from data frames, plot well-known geometry vectors, extract meta information from well-known geometry vectors, and calculate bounding boxes are provided.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://paleolimbot.github.io/wkutils/}
  \item \url{https://github.com/paleolimbot/wkutils}
  \item Report bugs at \url{https://github.com/paleolimbot/wkutils/issues}
}

}
\author{
\strong{Maintainer}: Dewey Dunnington \email{dewey@fishandwhistle.net} (\href{https://orcid.org/0000-0002-9415-4582}{ORCID})

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filters.R
\name{wkt_set_srid}
\alias{wkt_set_srid}
\alias{wkb_set_srid}
\alias{wkt_set_z}
\alias{wkb_set_z}
\alias{wkt_transform}
\alias{wkb_transform}
\title{Modify well-known geometries}
\usage{
wkt_set_srid(wkt, srid, precision = 16, trim = TRUE)

wkb_set_srid(wkb, srid)

wkt_set_z(wkt, z, precision = 16, trim = TRUE)

wkb_set_z(wkb, z)

wkt_transform(wkt, trans, precision = 16, trim = TRUE)

wkb_transform(wkb, trans)
}
\arguments{
\item{wkt}{A character vector containing well-known text.}

\item{srid}{An integer spatial reference identifier with a user-defined meaning.
Use \code{NA} to unset this value.}

\item{precision}{The rounding precision to use when writing
(number of decimal places).}

\item{trim}{Trim unnecessary zeroes in the output?}

\item{wkb}{A \code{list()} of \code{\link[=raw]{raw()}} vectors, such as that
returned by \code{sf::st_as_binary()}.}

\item{z}{A Z value that will be assigned to every coordinate in each feature.
Use \code{NA} to unset this value.}

\item{trans}{A 3x3 transformation matrix that will be applied to all coordinates
in the input.}
}
\value{
An unclassed well-known vector with the same type
as the input.
}
\description{
Modify well-known geometries
}
\examples{
wkt_set_srid("POINT (30 10)", 1234)
wkt_set_z("POINT (30 10)", 1234)
wkt_transform(
  "POINT (0 0)",
  # translation +12 +13
  matrix(c(1, 0, 0, 0, 1, 0, 12, 13, 1), ncol = 3)
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grob.R
\name{wkt_grob}
\alias{wkt_grob}
\alias{wkb_grob}
\title{Generate grid geometries from well-known geometries}
\usage{
wkt_grob(
  wkt,
  ...,
  rule = "evenodd",
  default.units = "native",
  name = NULL,
  vp = NULL
)

wkb_grob(
  wkt,
  ...,
  rule = "evenodd",
  default.units = "native",
  name = NULL,
  vp = NULL
)
}
\arguments{
\item{wkt}{A character vector containing well-known text.}

\item{...}{Graphical parameters passed to \code{\link[grid:gpar]{grid::gpar()}}. These are recycled along
the input. Dynamic dots (e.g., \verb{!!!}) are supported.}

\item{rule}{Use "winding" if polygon rings are correctly encoded with a winding
direction.}

\item{default.units}{Coordinate units, which may be defined by the viewport (see
\code{\link[grid:unit]{grid::unit()}}). Defaults to native.}

\item{name, vp}{Passed to \code{\link[grid:grid.points]{grid::pointsGrob()}}, \code{\link[grid:grid.lines]{grid::polylineGrob()}},
\code{\link[grid:grid.path]{grid::pathGrob()}}, or \code{\link[grid:grid.grob]{grid::gTree()}} depending on the types of geometries
in the input.}
}
\value{
A \link[grid:grid.grob]{graphical object}
}
\description{
Using \code{\link[=wkt_meta]{wkt_meta()}} and \code{\link[=wkt_coords]{wkt_coords()}}, these functions create graphical objects
using the grid package. Vectors that contain geometries of a single dimension
are efficiently packed into a \code{\link[grid:grid.points]{grid::pointsGrob()}}, \code{\link[grid:grid.lines]{grid::polylineGrob()}},
or \code{\link[grid:grid.path]{grid::pathGrob()}}. Vectors with mixed types and nested collections are encoded
less efficiently using a \code{\link[grid:grid.grob]{grid::gTree()}}.
}
\examples{
grid::grid.newpage()
grid::grid.draw(wkt_grob("POINT (0.5 0.5)", pch = 16, default.units = "npc"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/unnest.R
\name{wkt_unnest}
\alias{wkt_unnest}
\alias{wkb_unnest}
\title{Flatten nested geometry structures}
\usage{
wkt_unnest(wkt, keep_empty = FALSE, keep_multi = TRUE, max_depth = 1)

wkb_unnest(wkb, keep_empty = FALSE, keep_multi = TRUE, max_depth = 1)
}
\arguments{
\item{wkt}{A character vector containing well-known text.}

\item{keep_empty}{If \code{TRUE}, a GEOMETRYCOLLECTION EMPTY is left as-is
rather than collapsing to length 0.}

\item{keep_multi}{If \code{TRUE}, MULTI* geometries are not expanded to sub-features.}

\item{max_depth}{The maximum recursive GEOMETRYCOLLECTION depth to unnest.}

\item{wkb}{A \code{list()} of \code{\link[=raw]{raw()}} vectors, such as that
returned by \code{sf::st_as_binary()}.}
}
\value{
An unclassed vector with attribute \code{lengths}, which is an integer vector
with the same length as the input denoting the length to which each
feature was expanded.
}
\description{
Flatten nested geometry structures
}
\examples{
wkt_unnest("GEOMETRYCOLLECTION (POINT (1 2), POINT (3 4))")
wkt_unnest("GEOMETRYCOLLECTION EMPTY")
wkt_unnest("GEOMETRYCOLLECTION EMPTY", keep_empty = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meta.R
\name{wkb_meta}
\alias{wkb_meta}
\alias{wkt_meta}
\alias{wkt_streamer_meta}
\alias{wk_geometry_type}
\alias{wk_geometry_type_id}
\title{Extract meta information}
\usage{
wkb_meta(wkb, recursive = FALSE)

wkt_meta(wkt, recursive = FALSE)

wkt_streamer_meta(wkt, recursive = FALSE)

wk_geometry_type(type_id)

wk_geometry_type_id(type)
}
\arguments{
\item{wkb}{A \code{list()} of \code{\link[=raw]{raw()}} vectors, such as that
returned by \code{sf::st_as_binary()}.}

\item{recursive}{Pass \code{TRUE} to recurse into multi-geometries
and collections to extract meta of sub-geometries}

\item{wkt}{A character vector containing well-known text.}

\item{type_id}{An integer version of the geometry type}

\item{type}{A string version of the geometry type (e.g.,
point, linestring, polygon, multipoint, multilinestring,
multipolygon, geometrycollection)}
}
\value{
A data.frame with columns:
\itemize{
\item \code{feature_id}: The index of the top-level feature
\item \code{nest_id}: The recursion level (if feature is a geometry collection)
\item \code{part_id}: The part index (if nested within a multi-geometry or collection)
\item \code{type_id}: The type identifier (see \code{\link[=wk_geometry_type]{wk_geometry_type()}})
\item \code{size}: For points and linestrings the number of points, for polygons
the number of rings, and for mutlti-geometries and collection types,
the number of child geometries.
\item \code{srid}: The spatial reference identifier as an integer
}
}
\description{
Extract meta information
}
\examples{
wkt_meta("POINT (30 10)")
wkt_meta("GEOMETRYCOLLECTION (POINT (30 10))", recursive = FALSE)
wkt_meta("GEOMETRYCOLLECTION (POINT (30 10))", recursive = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{wkt_plot}
\alias{wkt_plot}
\alias{wkb_plot}
\title{Plot well-known geometry vectors}
\usage{
wkt_plot(
  x,
  ...,
  asp = 1,
  bbox = NULL,
  xlab = "",
  ylab = "",
  rule = "evenodd",
  add = FALSE
)

wkb_plot(
  x,
  ...,
  asp = 1,
  bbox = NULL,
  xlab = "",
  ylab = "",
  rule = "evenodd",
  add = FALSE
)
}
\arguments{
\item{x}{A \code{\link[=wkt]{wkt()}} or \code{\link[=wkb]{wkb()}} vector.}

\item{...}{Passed to plotting functions for features: \code{\link[graphics:points]{graphics::points()}}
for point and multipoint geometries, \code{\link[graphics:lines]{graphics::lines()}} for linestring
and multilinestring geometries, and \code{\link[graphics:polypath]{graphics::polypath()}} for polygon
and multipolygon geometries.}

\item{asp, xlab, ylab}{Passed to \code{\link[graphics:plot.default]{graphics::plot()}}}

\item{bbox}{The limits of the plot in the form returned by \code{\link[=wkt_ranges]{wkt_ranges()}}.}

\item{rule}{The rule to use for filling polygons (see \code{\link[graphics:polypath]{graphics::polypath()}})}

\item{add}{Should a new plot be created, or should \code{x} be added to the
existing plot?}
}
\value{
\code{x}, invisibly
}
\description{
These plot functions are intended to help debug geometry vectors,
and are not intended to be high-performance.
}
\examples{
wkt_plot("POINT (30 10)")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/finite.R
\name{wkt_has_missing}
\alias{wkt_has_missing}
\alias{wkb_has_missing}
\alias{wkt_is_finite}
\alias{wkb_is_finite}
\title{Test well-known geometries for missing and non-finite coordinates}
\usage{
wkt_has_missing(wkt)

wkb_has_missing(wkb)

wkt_is_finite(wkt)

wkb_is_finite(wkb)
}
\arguments{
\item{wkt}{A character vector containing well-known text.}

\item{wkb}{A \code{list()} of \code{\link[=raw]{raw()}} vectors, such as that
returned by \code{sf::st_as_binary()}.}
}
\value{
A logical vector with the same length as the input.
}
\description{
Note that EMTPY geometries are considered finite and non-missing.
Use the \code{size} column of \code{\link[=wkt_meta]{wkt_meta()}} to test for empty geometries.
}
\examples{
wkt_has_missing("POINT (0 1)")
wkt_has_missing("POINT (nan nan)")
wkt_has_missing("POINT (inf inf)")

wkt_is_finite("POINT (0 1)")
wkt_is_finite("POINT (nan nan)")
wkt_is_finite("POINT (inf inf)")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/draw.R
\name{wkb_draw_points}
\alias{wkb_draw_points}
\alias{wkt_draw_points}
\alias{wkb_draw_lines}
\alias{wkt_draw_lines}
\alias{wkb_draw_polypath}
\alias{wkt_draw_polypath}
\alias{wkb_plot_new}
\alias{wkt_plot_new}
\title{Draw well-known geometries}
\usage{
wkb_draw_points(wkb, ...)

wkt_draw_points(wkt, ...)

wkb_draw_lines(wkb, ...)

wkt_draw_lines(wkt, ...)

wkb_draw_polypath(wkb, ..., rule = "evenodd")

wkt_draw_polypath(wkt, ..., rule = "evenodd")

wkb_plot_new(
  wkb,
  ...,
  asp = 1,
  xlab = "",
  ylab = "",
  main = deparse(substitute(wkb))
)

wkt_plot_new(
  wkt,
  ...,
  asp = 1,
  xlab = "",
  ylab = "",
  main = deparse(substitute(wkt))
)
}
\arguments{
\item{wkb}{A \code{list()} of \code{\link[=raw]{raw()}} vectors, such as that
returned by \code{sf::st_as_binary()}.}

\item{...}{Passed to \code{\link[graphics:points]{graphics::points()}},
\code{\link[graphics:lines]{graphics::lines()}}, or \code{\link[graphics:polypath]{graphics::polypath()}}}

\item{wkt}{A character vector containing well-known text.}

\item{rule}{Passed to \code{\link[graphics:polypath]{graphics::polypath()}}}

\item{asp, xlab, ylab, main}{Passed to \code{\link[graphics:plot.default]{graphics::plot()}} to
initialize a new plot.}
}
\value{
The input, invisibly
}
\description{
These functions send well-known geometry vectors to a
graphics device using \code{\link[graphics:points]{graphics::points()}},
\code{\link[graphics:lines]{graphics::lines()}}, and \code{\link[graphics:polypath]{graphics::polypath()}}. These are
minimal wrappers aimed at developers who need to visualize
test data: they do not check geometry type and are unlikely
to work with vectorized graphical parameters in \code{...}. Use
the \verb{wk*_plot_new()} functions to initialize a plot using the
extent of all coordinates in the vector.
}
\examples{
x <- "POLYGON ((0 0, 10 0, 10 10, 0 10, 0 0))"

wkt_plot_new(x)
wkt_draw_polypath(x, col = "grey90")
wkt_draw_lines(x, col = "red")
wkt_draw_points(x)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/debug.R
\name{wkb_debug}
\alias{wkb_debug}
\alias{wkt_debug}
\alias{wkt_streamer_debug}
\title{Debug well-known geometry}
\usage{
wkb_debug(wkb)

wkt_debug(wkt)

wkt_streamer_debug(wkt)
}
\arguments{
\item{wkb}{A \code{list()} of \code{\link[=raw]{raw()}} vectors, such as that
returned by \code{sf::st_as_binary()}.}

\item{wkt}{A character vector containing well-known text.}
}
\value{
The input, invisibly
}
\description{
Prints the raw calls to the \code{WKBGeometryHandler()}. Useful for writing
custom C++ handlers and debugging read problems.
}
\examples{
wkt_debug("MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))")
wkt_streamer_debug("MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))")
wkb_debug(
  wk::wkt_translate_wkb(
    "MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))"
  )
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coords.R
\name{wkb_coords}
\alias{wkb_coords}
\alias{wkt_coords}
\title{Extract coordinates from well-known geometries}
\usage{
wkb_coords(wkb, sep_na = FALSE)

wkt_coords(wkt, sep_na = FALSE)
}
\arguments{
\item{wkb}{A \code{list()} of \code{\link[=raw]{raw()}} vectors, such as that
returned by \code{sf::st_as_binary()}.}

\item{sep_na}{Use \code{TRUE} to separate geometries and linear
rings with a row of \code{NA}s. This is useful for generating
output that can be fed directly to \code{\link[graphics:polypath]{graphics::polypath()}}
or \code{\link[graphics:lines]{graphics::lines()}} without modification.}

\item{wkt}{A character vector containing well-known text.}
}
\value{
A data.frame with columns:
\itemize{
\item \code{feature_id}: The index of the top-level feature
\item \code{part_id}: The part identifier, guaranteed to be unique for every simple geometry
(including those contained within a multi-geometry or collection)
\item \code{ring_id}: The ring identifier, guaranteed to be unique for every ring.
\item \code{x}, \code{y}, \code{z}, \code{m}: Coordinaate values (both absence and \code{nan} are recorded
as \code{NA})
}
}
\description{
These functions are optimised for graphics output,
which in R require flat coordinate structures. See
\code{\link[graphics:points]{graphics::points()}}, \code{\link[graphics:lines]{graphics::lines()}},
and  \code{\link[graphics:polypath]{graphics::polypath()}} for how to send these
to a graphics device, or \code{\link[grid:grid.points]{grid::pointsGrob()}},
\code{\link[grid:grid.lines]{grid::linesGrob()}}, and \code{\link[grid:grid.path]{grid::pathGrob()}} for how
to create graphical objects using this output.
}
\examples{
text <- c("LINESTRING (0 1, 19 27)", "LINESTRING (-1 -1, 4 10)")
wkt_coords(text)
wkt_coords(text, sep_na = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ranges.R
\name{wkb_ranges}
\alias{wkb_ranges}
\alias{wkt_ranges}
\alias{wkb_feature_ranges}
\alias{wkt_feature_ranges}
\title{Extract ranges information}
\usage{
wkb_ranges(wkb, na.rm = FALSE, finite = FALSE)

wkt_ranges(wkt, na.rm = FALSE, finite = FALSE)

wkb_feature_ranges(wkb, na.rm = FALSE, finite = FALSE)

wkt_feature_ranges(wkt, na.rm = FALSE, finite = FALSE)
}
\arguments{
\item{wkb}{A \code{list()} of \code{\link[=raw]{raw()}} vectors, such as that
returned by \code{sf::st_as_binary()}.}

\item{na.rm}{Pass \code{TRUE} to not consider missing (nan) values}

\item{finite}{Pass \code{TRUE} to only consider finite
(non-missing, non-infinite) values.}

\item{wkt}{A character vector containing well-known text.}
}
\value{
A data.frame with columns:
\itemize{
\item \code{xmin}, \code{ymin}, \code{zmin}, and \code{mmin}: Minimum coordinate values
\item \code{xmax}, \code{ymax}, \code{zmax}, and \code{mmax}: Maximum coordinate values
}
}
\description{
This is intended to behave the same as \code{\link[=range]{range()}}, returning the
minimum and maximum x, y, z, and m coordinate values.
}
\examples{
wkt_ranges("POINT (30 10)")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coords-translate.R
\name{coords_point_translate_wkt}
\alias{coords_point_translate_wkt}
\alias{coords_point_translate_wkb}
\alias{coords_linestring_translate_wkt}
\alias{coords_linestring_translate_wkb}
\alias{coords_polygon_translate_wkt}
\alias{coords_polygon_translate_wkb}
\title{Parse coordinates into well-known formats}
\usage{
coords_point_translate_wkt(x, y, z = NA, m = NA, precision = 16, trim = TRUE)

coords_point_translate_wkb(
  x,
  y,
  z = NA,
  m = NA,
  endian = wk::wk_platform_endian(),
  buffer_size = 2048
)

coords_linestring_translate_wkt(
  x,
  y,
  z = NA,
  m = NA,
  feature_id = 1L,
  precision = 16,
  trim = TRUE
)

coords_linestring_translate_wkb(
  x,
  y,
  z = NA,
  m = NA,
  feature_id = 1L,
  endian = wk::wk_platform_endian(),
  buffer_size = 2048
)

coords_polygon_translate_wkt(
  x,
  y,
  z = NA,
  m = NA,
  feature_id = 1L,
  ring_id = 1L,
  precision = 16,
  trim = TRUE
)

coords_polygon_translate_wkb(
  x,
  y,
  z = NA,
  m = NA,
  feature_id = 1L,
  ring_id = 1L,
  endian = wk::wk_platform_endian(),
  buffer_size = 2048
)
}
\arguments{
\item{x, y, z, m}{Vectors of coordinate values}

\item{precision}{The rounding precision to use when writing
(number of decimal places).}

\item{trim}{Trim unnecessary zeroes in the output?}

\item{endian}{Force the endian of the resulting WKB.}

\item{buffer_size}{The buffer size to use when converting to WKB.}

\item{feature_id, ring_id}{Vectors for which a change in
sequential values indicates a new feature or ring. Use \code{\link[=factor]{factor()}}
to convert from a character vector.}
}
\value{
\verb{*_translate_wkt()} returns a character vector of
well-known text; \verb{*_translate_wkb()} returns a list
of raw vectors.
}
\description{
These functions provide the reverse function of \code{\link[=wkt_coords]{wkt_coords()}}
and company: they parse vectors of coordinate values into well-known
formats. Polygon rings are automatically closed, as
closed rings are assumed or required by many parsers.
}
\examples{
coords_point_translate_wkt(1:3, 2:4)
coords_linestring_translate_wkt(1:5, 2:6, feature_id = c(1, 1, 1, 2, 2))
coords_polygon_translate_wkt(c(0, 10, 0), c(0, 0, 10))

}
